"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateQuery = void 0;
const allowed_1 = require("./allowed");
const utils_1 = require("./utils");
function validateQuery(queryObj, allowedOperators = allowed_1.ALLOWED_OPERATORS) {
    const invalidFields = [];
    const stack = [
        { obj: queryObj, path: '' },
    ];
    while (stack.length > 0) {
        const { obj, path } = stack.pop();
        (0, utils_1.processObject)(obj, path, allowedOperators, invalidFields, stack);
    }
    return {
        isValidQuery: !invalidFields.length,
        invalidFields,
    };
}
exports.validateQuery = validateQuery;
