"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateField = exports.processObject = void 0;
function processObject(obj, path, allowedOperators, invalidFields, stack) {
    for (const key in obj) {
        const newPath = path ? `${path}.${key}` : key;
        // validate the current
        validateField(key, newPath, allowedOperators, invalidFields);
        // if the object value is an object traverse it
        if (typeof obj[key] === 'object' && obj[key] !== null) {
            stack.push({ obj: obj[key], path: newPath });
        }
    }
}
exports.processObject = processObject;
function validateField(key, path, allowedOperators, invalidFields) {
    // only validate key starting with $ to check of invalid MongoDB uperator
    // eg: $exists is valid $exist is a common typo
    if (key.startsWith('$') && !allowedOperators.includes(key)) {
        invalidFields.push(path);
    }
}
exports.validateField = validateField;
